﻿using System;

namespace AdrianKousz.Util.Logging
{
	internal static class Helper
	{
		public static bool IsDebug()
		{
			var result = false;
			#if DEBUG
			result = true;
			#endif
			return result;
		}

		public static Logger GetDefault()
		{
			return DefaultLogger.instance;
		}

		public static void SetHandler()
		{
			AppDomain.CurrentDomain.UnhandledException += HandleException;
		}

		public static void Log(object e)
		{
			var level = AdrianKousz.Util.Log.ALERT;
			var tag = "Exception";
			var t = System.Threading.Thread.CurrentThread;
			var id = t.Name ?? t.ManagedThreadId.ToString();
			var msg = string.Format("In thread \"{0}\" as {1}", id, e);
			AdrianKousz.Util.Log.log(level, tag, msg);
		}

		private static void HandleException(object sender, UnhandledExceptionEventArgs args)
		{
			Log(args.ExceptionObject);
		}

		private static class DefaultLogger
		{
			internal static SimpleLogger instance;
			static DefaultLogger()
			{
				instance = new SimpleLogger(Console.Error);
			}
		}
	}
}

