﻿namespace AdrianKousz.Util
{
	public static class Math
	{
		private static readonly System.Random uniform = new System.Random();

		public static int Rand(int min, int max)
		{
			return uniform.Next(min, max);
		}

		public static double Rand(double min, double max)
		{
			return min + (max - min) * uniform.NextDouble();
		}

		public static double Round(double x, double factor = 1.0)
		{
			return System.Math.Round(x / factor) * factor;
		}

		public static int Clamp(int x, int min, int max)
		{
			if (x < min) return min;
			if (x > max) return max;
			return x;
		}

		public static double Clamp(double x, double min = 0.0, double max = 1.0)
		{
			if (x < min) return min;
			if (x > max) return max;
			return x;
		}
	}
}

