﻿using System;
using System.IO;

namespace AdrianKousz.Util
{
	public static class Misc
	{
		public static string Randstr(int length = 0, string charset = null)
		{
			if (length == 0) length = 12;
			if (charset == null) charset = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			var resultArray = new char[length];
			var charsetArray = charset.ToCharArray();
			for (int i = 0; i < length; i++) resultArray[i] = charsetArray[Math.Rand(0, charsetArray.Length)];
			return new string(resultArray);
		}

		public static string ToString(object o)
		{
			return o == null ? "null" : o.ToString();
		}

		public static T MayNew<T>(T o) where T : new()
		{
			if (o == null) return new T();
			return o;
		}

		public static T MayNew<T>(T o, Func<T> f)
		{
			if (o == null) return f();
			return o;
		}

		public static StreamReader GetReader(this Stream s)
		{
			return new StreamReader(s);
		}

		public static StreamWriter GetWriter(this Stream s)
		{
			return new StreamWriter(s);
		}

		public static void CopyTo(this Stream sin, Stream sout) {
			var bufferlength = 10240;
			var buffer = new byte[bufferlength];
			var read = 0;
			while ((read = sin.Read(buffer, 0, bufferlength)) > 0) {
				sout.Write(buffer, 0, read);
			}
		}

		public static byte[] ReadBytes(this Stream stream, int count)
		{
			var result = new byte[count];
			stream.Read(result, 0, count);
			return result;
		}

		public static void Write(this Stream stream, byte[] array)
		{
			stream.Write(array, 0, array.Length);
		}

		public static bool ParseBoolean(string s)
		{
			s = s.Trim().ToLower();
			if (s.Equals("true") || s.Equals("yes") || s.Equals("on")) return true;
			if (s.Equals("false") || s.Equals("no") || s.Equals("off") || s.Equals("")) return false;
			return 0 != int.Parse(s);
		}
	}
}
